## dtkgui 5.6.2.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

set (DVERSION "5.6.2" CACHE STRING "define project version")
project(DtkGui
  VERSION ${DVERSION}
  DESCRIPTION "DTK Gui module"
  HOMEPAGE_URL "https://github.com/linuxdeepin/dtkgui"
  LANGUAGES CXX C
)

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

# Set build option
option(NOTPACKAGE "to make package" ON)
option(DTK_DISABLE_LIBXDG "Disabel libxdg" OFF)
set (BUILD_DOCS ON CACHE BOOL "Generate doxygen-based documentation")

# Set install path
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()
set (INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_FULL_INCLUDEDIR}/libdtk-${PROJECT_VERSION}/DGui")
set (TOOL_INSTALL_DIR "${CMAKE_INSTALL_FULL_LIBDIR}/libdtk-${PROJECT_VERSION}/DGui/bin")
set (LIBRARY_INSTALL_DIR "${CMAKE_INSTALL_FULL_LIBDIR}")
set (MKSPECS_INSTALL_DIR "${CMAKE_INSTALL_FULL_LIBDIR}/qt5/mkspecs/modules" CACHE STRING "INSTALL DIR FOR qt pri files")

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -Wall -Wextra")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--as-needed")
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
  set(BUILD_TESTING ON)
else ()
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Ofast")
endif ()

set(CONFIGNAME include/global/dtkgui_config.h)
file(WRITE ${CONFIGNAME} 
  "// it is auto make config\n"
)
file(GLOB CONFIGSOURCE include/DtkGui/*)

foreach(FILENAME ${CONFIGSOURCE})
  get_filename_component(thefile ${FILENAME} NAME)
  file(APPEND ${CONFIGNAME} "#define DTKGUI_CLASS_${thefile}\n")
endforeach()

configure_package_config_file(misc/DtkGuiConfig.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/DtkGuiConfig.cmake
    INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/DtkGui"
    PATH_VARS INCLUDE_INSTALL_DIR LIBRARY_INSTALL_DIR TOOL_INSTALL_DIR
)
write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/DtkGuiConfigVersion.cmake"
    VERSION ${DVERSION}
    COMPATIBILITY SameMajorVersion
)
install(FILES
      ${CMAKE_CURRENT_BINARY_DIR}/DtkGuiConfig.cmake
      ${CMAKE_CURRENT_BINARY_DIR}/DtkGuiConfigVersion.cmake
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/DtkGui"
)

configure_file(misc/dtkgui.pc.in dtkgui.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/dtkgui.pc DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig/")

configure_file(misc/qt_lib_dtkgui.pri.in qt_lib_dtkgui.pri @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qt_lib_dtkgui.pri DESTINATION "${MKSPECS_INSTALL_DIR}")

set(GUISGNAME DtkGuis)

file(WRITE ${GUISGNAME} 
  "// it is auto make config\n"
  "#ifndef DTK_GUI_MODULE_H\n"
  "#define DTK_GUI_MODULE_H\n"
)
file(GLOB FILEGRAGTOWRITSOURCE include/filedrag/*)

foreach(FILENAME ${FILEGRAGTOWRITSOURCE})
  get_filename_component(thefile ${FILENAME} NAME)
  file(APPEND ${GUISGNAME} "#include \"${thefile}\"\n")
endforeach()
file(GLOB KERNELTOWRITESOURCE include/kernel/*)
foreach(FILENAME ${KERNELTOWRITESOURCE})
  get_filename_component(thefile ${FILENAME} NAME)
  file(APPEND ${GUISGNAME} "#include \"${thefile}\"\n")
endforeach()
file(GLOB UTILTOWRITESOURCE include/util/*)
foreach(FILENAME ${UTILTOWRITESOURCE})
  get_filename_component(thefile ${FILENAME} NAME)
  file(APPEND ${GUISGNAME} "#include \"${thefile}\"\n")
endforeach()
file(APPEND ${GUISGNAME} "#endif")
install(FILES DtkGuis DESTINATION "${INCLUDE_INSTALL_DIR}")

add_subdirectory(examples)
add_subdirectory(src)
if(BUILD_TESTING)
  message("==================================")
  message("       Now Testing is enabled     ")
  message("==================================")
  enable_testing()
  add_subdirectory(tests)
endif()
add_subdirectory(tools)

if (BUILD_DOCS)
  add_subdirectory(docs)
endif ()

=== tools/deepin-gui-settings/CMakeLists.txt ===
set(BIN_NAME deepin-gui-settings)
set(CMAKE_AUTOMOC ON)

find_package(Qt5 REQUIRED COMPONENTS Widgets)
find_package(DtkCore REQUIRED)

add_executable(${BIN_NAME} 
  main.cpp 
)

target_link_libraries(${BIN_NAME}
  Qt5::Widgets 
  dtkgui
  ${DtkCore_LIBRARIES}
)
target_include_directories(${BIN_NAME} PUBLIC
  ../../include/kernel/
  ../../include/DtkGui/
  ../../include/util/
  ../../include/
  ${DtkCore_INCLUDE_DIRS}
)
install(TARGETS ${BIN_NAME} DESTINATION "${TOOL_INSTALL_DIR}")

## dtkgui 5.2.2.4

=== debian/changelog ===
dtkgui (5.2.2.4-2) unstable; urgency=medium

  * debian/patches:
    + Use detected pkg-config to fix cross build (Closes: #979451).
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Arun Kumar Pariyar <openarungeek@gmail.com>  Tue, 12 Jan 2021 00:21:00 +0545

dtkgui (5.2.2.4-1) unstable; urgency=medium

  * Upload to unstable.
  * debian/control: Bump Standards-Version to 4.5.1.

 -- Arun Kumar Pariyar <openarungeek@gmail.com>  Sun, 29 Nov 2020 00:25:26 +0545

dtkgui (5.2.2.4-1~exp1) experimental; urgency=medium

  [ Hu Feng ]
  * New upstream release 5.2.2.4.
  * debian/control:
    + Remove Build-Depends libqt5x11extras5-dev
  * debian/libdtkgui5.shlibs
    + Change libdtkgui 5 libdtkgui5 (>= 5.2.2.4)

  [ Arun Kumar Pariyar ]
  * debian/copyright:
    + Update copyright info from GPL-3+ to LGPL-3+
  * debian/control:
    + Update section for -bin and -dev binary packages.

 -- Arun Kumar Pariyar <openarungeek@gmail.com>  Mon, 02 Nov 2020 02:36:02 +0545

dtkgui (5.2.2.1-1~exp1) experimental; urgency=medium

  * New upstream release 5.2.2.1.
  * debian/patches:
    + Remove dbus-policy-excessively-broad (already patched upstream).

 -- Arun Kumar Pariyar <openarungeek@gmail.com>  Sun, 12 Jul 2020 15:15:10 +0545

dtkgui (5.2.0-1~exp1) experimental; urgency=medium

  * New upstream release 5.2.0.
  * debian/patches:
    + Fix for lintian dbus-policy-excessively-broad error

 -- Arun Kumar Pariyar <openarungeek@gmail.com>  Wed, 20 May 2020 02:59:37 +0545

=== debian/control ===
Source: dtkgui
Section: libs
Priority: optional
Maintainer: Debian Deepin Packaging Team <pkg-deepin-devel@lists.alioth.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
 Arun Kumar Pariyar <openarungeek@gmail.com>,
 Hu Feng <hufeng@uniontech.com>,
Build-Depends:
 debhelper-compat (= 13),
 libdtkcore-dev (>= 5.0.0),
 librsvg2-dev,
 pkg-config,
 qtbase5-dev-tools,
 qtbase5-private-dev,
Rules-Requires-Root: no
Standards-Version: 4.5.1
Homepage: https://github.com/linuxdeepin/dtkgui
Vcs-Git: https://salsa.debian.org/pkg-deepin-team/dtkgui.git
Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/dtkgui

Package: libdtkgui-dev
Architecture: any
Section: libdevel
Depends:
 libdtkgui5 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Deepin Tool Kit Gui library (development files)
 DtkGui provides the base devel library of Deepin Qt/C++
 applications.
 .
 This package provides the library development files.
 .
 This package is part of DDE (Deepin Desktop Environment).

Package: libdtkgui5
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: same
Description: Deepin Tool Kit Gui library
 DtkGui provides the base devel library of Deepin Qt/C++
 applications.
 .
 This package provides the shared library files.
 .
 This package is part of DDE (Deepin Desktop Environment).

Package: libdtkgui5-bin
Section: utils
Architecture: any
Depends:
 libdtkgui5 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Deepin Tool Kit Gui utilities
 DtkGui provides the base devel library of Deepin Qt/C++
 applications.
 .
 This package provides the utilities of DtkGui.
 .
 This package is part of DDE (Deepin Desktop Environment).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export QT_SELECT := 5

# Retrieve version info
include /usr/share/dpkg/default.mk

# Explicitly enable hardening
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

include /usr/share/dpkg/architecture.mk

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- LIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)

execute_after_dh_auto_install:
	find debian/tmp/usr/include/libdtk-5.2.2/DCore/ -type d -empty -delete

## dtkgui 5.4.13

=== debian/changelog ===
dtkgui (5.4.13-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Thu, 25 Mar 2021 17:26:25 +0800

dtkgui (5.0.0) unstable; urgency=medium

  * Release 5.0.0

 -- Deepin Packages Builder <packages@deepin.com>  Tue, 03 Sep 2019 08:59:03 +0800

dtkgui (1.0.0-1) unstable; urgency=medium

  * Initial release 

 -- Deepin Packages Builder <packages@deepin.com>  Mon, 29 Jul 2019 16:58:07 +0800

=== debian/control ===
Source: dtkgui
Section: libdevel
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends: debhelper (>= 9), pkg-config, 
 qtbase5-private-dev, qtbase5-dev-tools,
 libdtkcore-dev, librsvg2-dev, libgtest-dev
Standards-Version: 3.9.8

Package: libdtkgui5
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libdtkcommon
Multi-Arch: same
Description: Deepin Tool Kit Gui library
 DtkGui is base library of Deepin Qt/C++ applications.
 .
 This package contains the shared libraries.

Package: libdtkgui5-bin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libdtkgui5( =${binary:Version})
Description: Deepin Tool Kit Gui Utilities
 DtkGui is base devel library of Deepin Qt/C++ applications.
 .
 This package contains the utilities of DtkGui

Package: libdtkgui-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libdtkgui5( =${binary:Version})
Description: Deepin Tool Kit Gui Devel library
 DtkGui is base devel library of Deepin Qt/C++ applications.
 .
 This package contains the header files and static libraries of DtkGui

=== debian/rules ===
#!/usr/bin/make -f
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
export QT_SELECT = qt5

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

ifneq (,$(wildcard .git/config))
	CONFIG_VERSION=
else
VERSION = $(DEB_VERSION_UPSTREAM)
_PACK_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$1}')
_BUILD_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$2}' | sed 's/[^0-9]//g')
ifeq ($(_BUILD_VER),)
	CONFIG_VERSION = $(_PACK_VER)
else
	CONFIG_VERSION = $(_PACK_VER).$(_BUILD_VER)
endif
endif

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- LIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) VERSION=$(CONFIG_VERSION)

override_dh_auto_test:
	echo "skip auto test"

override_dh_makeshlibs:
	dh_makeshlibs  -V "libdtkgui5 (>= $(shell echo $(VERSION) | cut -d '.' -f 1,2))"

## dtkgui 5.5.21

=== debian/changelog ===
dtkgui (5.5.21-1build1) jammy; urgency=medium

  * No-change rebuild against Qt 5.15.3.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Thu, 17 Mar 2022 18:36:01 +0300

dtkgui (5.5.21-1) unstable; urgency=medium

  * New upstream version 5.5.21.
  * debian/copyright: updated.
  * debian/libdtkgui5.shlibs: update to version 5.5.21.

 -- Clay Stan <claystan97@gmail.com>  Mon, 21 Feb 2022 15:37:47 +0800

dtkgui (5.5.17.1-1) unstable; urgency=medium

  * New upstream version 5.5.17.1.
  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Tue, 09 Nov 2021 15:11:05 -0500

dtkgui (5.5.17-1~exp1) experimental; urgency=medium

  [ Clay Stan ]
  * add missing depends.

  [ Boyuan Yang ]
  * New upstream version 5.5.17. (Closes: #993175)
  * debian/libdtkgui5.symbols: Dropped, use shlibs file instead.
  * debian/control: Bump Standards-Version to 4.6.0.

 -- Boyuan Yang <byang@debian.org>  Sun, 07 Nov 2021 15:02:51 -0500

dtkgui (5.4.0-1~exp1) experimental; urgency=medium

  [ Clay Stan ]
  * New upstream release 5.4.0.

  [ Hu Feng ]
  * debian/patches:
    + Add 0002-fix-enable-style-for-no-dde.patch
  * debian/libdtkgui5.shlibs
    + Change libdtkgui 5 libdtkgui5 (>= 5.4.0)
  * debian/control:
    + Tighten version of libdtkcore-dev to (>= 5.4~)

 -- Hu Feng <hufeng@uniontech.com>  Thu, 25 Feb 2021 13:56:50 +0800

=== debian/control ===
Source: dtkgui
Section: libs
Priority: optional
Maintainer: Debian Deepin Packaging Team <pkg-deepin-devel@lists.alioth.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
 Arun Kumar Pariyar <openarungeek@gmail.com>,
 Hu Feng <hufeng@uniontech.com>,
 Clay Stan <claystan97@gmail.com>,
Build-Depends:
 debhelper-compat (= 13),
 libdtkcore-dev (>= 5.5.17~),
 librsvg2-dev,
 pkg-config,
 qtbase5-dev-tools,
 qtbase5-private-dev,
 libgtest-dev,
 libgmock-dev,
Rules-Requires-Root: no
Standards-Version: 4.6.0
Homepage: https://github.com/linuxdeepin/dtkgui
Vcs-Git: https://salsa.debian.org/pkg-deepin-team/dtkgui.git
Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/dtkgui

Package: libdtkgui-dev
Architecture: any
Section: libdevel
Depends:
 libdtkgui5 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Deepin Tool Kit Gui library (development files)
 DtkGui provides the base devel library of Deepin Qt/C++
 applications.
 .
 This package provides the library development files.
 .
 This package is part of DDE (Deepin Desktop Environment).

Package: libdtkgui5
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libdtkcommon,
Multi-Arch: same
Description: Deepin Tool Kit Gui library
 DtkGui provides the base devel library of Deepin Qt/C++
 applications.
 .
 This package provides the shared library files.
 .
 This package is part of DDE (Deepin Desktop Environment).

Package: libdtkgui5-bin
Section: utils
Architecture: any
Depends:
 libdtkgui5 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Deepin Tool Kit Gui utilities
 DtkGui provides the base devel library of Deepin Qt/C++
 applications.
 .
 This package provides the utilities of DtkGui.
 .
 This package is part of DDE (Deepin Desktop Environment).

## dtkgui 5.5.22

=== debian/changelog ===
dtkgui (5.5.22-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Sat, 07 May 2022 16:51:52 +0800

## dtkgui 5.5.24

=== debian/changelog ===
dtkgui (5.5.24-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Thu, 16 Jun 2022 10:46:11 +0800

## dtkgui 5.5.25

=== debian/changelog ===
dtkgui (5.5.25-2build4) noble; urgency=medium

  * No-change rebuild against Qt 5.15.13.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Thu, 04 Apr 2024 00:24:40 +0300

dtkgui (5.5.25-2build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:05:06 +0000

dtkgui (5.5.25-2build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 04:16:44 +0000

dtkgui (5.5.25-2build1) noble; urgency=medium

  * No-change rebuild against Qt 5.15.12.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Fri, 29 Dec 2023 00:06:49 +0300

dtkgui (5.5.25-2) unstable; urgency=medium

  * debian/clean: Clean generated files. (Closes: #1044740)
  * debian/control:
    + Update my email to debian.
    + Update Vcs-Git with debian/sid

 -- Arun Kumar Pariyar <arun@debian.org>  Mon, 04 Sep 2023 16:18:11 +0530

dtkgui (5.5.25-1) unstable; urgency=medium

  * New upstream release 5.5.25.
  * debian/libdtkgui5.shlibs: update to version 5.5.25.
  * debian/control: Bump Standards-Version to 4.6.1.0.

 -- Clay Stan <claystan97@gmail.com>  Tue, 02 Aug 2022 13:27:21 +0800

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: dtkgui
 Section: libs
 Priority: optional
-Maintainer: Debian Deepin Packaging Team <pkg-deepin-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Deepin Packaging Team <pkg-deepin-devel@lists.alioth.debian.org>
 Uploaders:
  Boyuan Yang <byang@debian.org>,
- Arun Kumar Pariyar <openarungeek@gmail.com>,
+ Arun Kumar Pariyar <arun@debian.org>,
  Hu Feng <hufeng@uniontech.com>,
  Clay Stan <claystan97@gmail.com>,
 Build-Depends:
@@ -17,9 +18,9 @@
  libgtest-dev,
  libgmock-dev,
 Rules-Requires-Root: no
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Homepage: https://github.com/linuxdeepin/dtkgui
-Vcs-Git: https://salsa.debian.org/pkg-deepin-team/dtkgui.git
+Vcs-Git: https://salsa.debian.org/pkg-deepin-team/dtkgui.git -b debian/sid
 Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/dtkgui
 
 Package: libdtkgui-dev

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4


# GitHub hosted projects
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%dtkgui-$1.tar.gz%" \
   https://github.com/linuxdeepin/dtkgui/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## dtkgui 5.5.26

=== debian/changelog ===
dtkgui (5.5.26-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Thu, 13 Oct 2022 15:00:14 +0800

## dtkgui 5.6.1.1

=== debian/changelog ===
dtkgui (5.6.1.1-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Fri, 11 Nov 2022 18:12:07 +0800

dtkgui (5.6.1.1) unstable; urgency=medium

  * snipe release 5.6.1.1

 -- Deepin Packages Builder <packages@deepin.com>  Wed, 22 Jun 2022 14:33:59 +0800

dtkgui (5.6.0.1) unstable; urgency=medium

  * Release 5.6.0.1

 -- Deepin Packages Builder <packages@deepin.com>  Tue, 14 Jun 2022 10:51:30 +0800

=== debian/control ===
Source: dtkgui
Section: libdevel
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends: debhelper (>= 9), pkg-config, 
 qtbase5-private-dev, qtbase5-dev-tools,
 libdtkcore-dev, librsvg2-dev, libgtest-dev, libgmock-dev,
 libqt5xdg-dev, libqt5xdgiconloader-dev
Standards-Version: 3.9.8

Package: libdtkgui5
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libdtkcommon,
 qt5-image-formats-plugins
Multi-Arch: same
Description: Deepin Tool Kit Gui library
 DtkGui is base library of Deepin Qt/C++ applications.
 .
 This package contains the shared libraries.

Package: libdtkgui5-bin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libdtkgui5( =${binary:Version})
Description: Deepin Tool Kit Gui Utilities
 DtkGui is base devel library of Deepin Qt/C++ applications.
 .
 This package contains the utilities of DtkGui

Package: libdtkgui-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libdtkgui5( =${binary:Version})
Description: Deepin Tool Kit Gui Devel library
 DtkGui is base devel library of Deepin Qt/C++ applications.
 .
 This package contains the header files and static libraries of DtkGui

## dtkgui 5.6.2.2

=== debian/changelog ===
dtkgui (5.6.2.2-2) unstable; urgency=medium

  * debian/rules: Set DDTK_DISABLE_LIBXDG to ON.
  * debian/control:
    + Drop libqt5xdg-dev, libqt5xdgiconloader-dev from B-D.

 -- Arun Kumar Pariyar <arun@debian.org>  Sun, 22 Dec 2024 22:51:15 +0545

dtkgui (5.6.2.2-1) unstable; urgency=medium

  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Fri, 06 Dec 2024 14:32:01 -0500

dtkgui (5.6.2.2-1~exp1) experimental; urgency=medium

  * New upstream release 5.6.2.2.
  * debian/control: Migrate to cmake.
  * debian/rules: Migrate to cmake.
  * debian/libdtkgui5.shlibs: update to version 5.6.2.

 -- Boyuan Yang <byang@debian.org>  Sat, 03 Dec 2022 10:39:58 -0500

=== debian/control ===
Source: dtkgui
Section: libs
Priority: optional
Maintainer: Debian Deepin Packaging Team <pkg-deepin-devel@lists.alioth.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
 Arun Kumar Pariyar <arun@debian.org>,
 Hu Feng <hufeng@uniontech.com>,
 Clay Stan <claystan97@gmail.com>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 doxygen <!nodoc>,
 libdtkcore-dev (>= 5.6~),
 libgmock-dev,
 libgtest-dev,
 librsvg2-dev,
 pkgconf,
 qtbase5-dev-tools,
 qtbase5-private-dev,
 qttools5-dev-tools,
Rules-Requires-Root: no
Standards-Version: 4.7.0
Homepage: https://github.com/linuxdeepin/dtkgui
Vcs-Git: https://salsa.debian.org/pkg-deepin-team/dtkgui.git
Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/dtkgui

Package: libdtkgui-dev
Architecture: any
Section: libdevel
Depends:
 libdtkgui5 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Deepin Tool Kit Gui library (development files)
 DtkGui provides the base devel library of Deepin Qt/C++
 applications.
 .
 This package provides the library development files.
 .
 This package is part of DDE (Deepin Desktop Environment).

Package: libdtkgui5
Architecture: any
Depends:
 libdtkcommon,
 qt5-image-formats-plugins,
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: same
Description: Deepin Tool Kit Gui library
 DtkGui provides the base devel library of Deepin Qt/C++
 applications.
 .
 This package provides the shared library files.
 .
 This package is part of DDE (Deepin Desktop Environment).

Package: libdtkgui5-bin
Section: utils
Architecture: any
Depends:
 libdtkgui5 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Deepin Tool Kit Gui utilities
 DtkGui provides the base devel library of Deepin Qt/C++
 applications.
 .
 This package provides the utilities of DtkGui.
 .
 This package is part of DDE (Deepin Desktop Environment).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export QT_SELECT := 5

# Explicitly enable hardening
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

include /usr/share/dpkg/architecture.mk

# Retrieve version info
include /usr/share/dpkg/default.mk


%:
	dh $@

# FIXME: Enable doc building
override_dh_auto_configure:
	dh_auto_configure -- \
	        -DBUILD_TESTING=OFF \
            -DBUILD_DOCS=OFF \
			-DDTK_DISABLE_LIBXDG=ON \
            -DDVERSION=$(DEB_VERSION_UPSTREAM) \
            $(NULL)

## dtkgui 5.6.2.2+1

=== examples/CMakeLists.txt ===
add_subdirectory(dnd-example)
add_subdirectory(test-taskbar)

=== tools/CMakeLists.txt ===
add_subdirectory(deepin-gui-settings)
add_subdirectory(dci-image-converter)
add_subdirectory(dde-kwin-debug)

=== debian/changelog ===
dtkgui (5.6.2.2+1-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Sat, 03 Dec 2022 15:23:24 +0800

dtkgui (5.6.2.2) unstable; urgency=medium

  * Release 5.6.2.2

 -- Deepin Packages Builder <packages@deepin.com>  Wed, 30 Nov 2022 10:32:07 +0800

## dtkgui 5.6.2.2+2

=== docs/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.10)

find_package (Doxygen REQUIRED)

set (QCH_INSTALL_DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/qt5/doc CACHE STRING "QCH install location")

set (DOXYGEN_GENERATE_HTML "YES" CACHE STRING "Doxygen HTML output")
set (DOXYGEN_GENERATE_XML "YES" CACHE STRING "Doxygen XML output")
set (DOXYGEN_GENERATE_QHP "YES" CACHE STRING "Doxygen QHP output")
set (DOXYGEN_FILE_PATTERNS *.cpp *.h *.zh_CN.md *.zh_CN.dox CACHE STRING "Doxygen File Patterns")
set (DOXYGEN_PROJECT_NUMBER ${CMAKE_PROJECT_VERSION} CACHE STRING "") # Should be the same as this project is using.
set (DOXYGEN_EXTRACT_STATIC YES)
set (DOXYGEN_OUTPUT_LANGUAGE "Chinese" CACHE STRING "Doxygen Output Language")
set (DOXYGEN_IMAGE_PATH ${CMAKE_CURRENT_LIST_DIR}/images/)
set (DOXYGEN_QHG_LOCATION "qhelpgenerator")
set (DOXYGEN_QHP_NAMESPACE "org.deepin.dtk.gui")
set (DOXYGEN_QCH_FILE "dtkgui.qch")
set (DOXYGEN_QHP_VIRTUAL_FOLDER "dtkgui")
set (DOXYGEN_HTML_EXTRA_STYLESHEET "" CACHE STRING "Doxygen custom stylesheet for HTML output")
set (DOXYGEN_TAGFILES "qtcore.tags=qthelp://org.qt-project.qtcore/qtcore/" CACHE STRING "Doxygen tag files")

set (DOXYGEN_PREDEFINED
    "D_DECL_DEPRECATED_X(x)="
    "\"DCORE_BEGIN_NAMESPACE=namespace Dtk { namespace Core {\""
    "\"DCORE_END_NAMESPACE=}}\""
    "\"DCORE_USE_NAMESPACE=using namespace Dtk::Core\;\""
    "\"DGUI_BEGIN_NAMESPACE=namespace Dtk { namespace Gui {\""
    "\"DGUI_END_NAMESPACE=}}\""
    "\"DGUI_USE_NAMESPACE=using namespace Dtk::Gui\;\""
)
set (DOXYGEN_MACRO_EXPANSION "YES")
set (DOXYGEN_EXPAND_ONLY_PREDEF "YES")

doxygen_add_docs (doxygen
    ${PROJECT_SOURCE_DIR}/src
    ${PROJECT_SOURCE_DIR}/include
    ${PROJECT_SOURCE_DIR}/docs
    ALL
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
    COMMENT "Generate documentation via Doxygen"
)

install (FILES ${PROJECT_BINARY_DIR}/docs/html/dtkgui.qch DESTINATION ${QCH_INSTALL_DESTINATION})

=== src/CMakeLists.txt ===
set(LIB_NAME dtkgui)
find_package(DtkCore 5.6 REQUIRED)
find_package(PkgConfig REQUIRED)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

find_package(Qt5 REQUIRED COMPONENTS Gui)
find_package(Qt5 REQUIRED COMPONENTS DBus)
find_package(Qt5 REQUIRED COMPONENTS Network)

include(dbus/dbus.cmake)
include(filedrag/dfiledrag.cmake)
include(kernel/kernel.cmake)
include(private/private.cmake)
include(util/util.cmake)

add_library(${LIB_NAME} SHARED 
  ${dbus_SRC}
  ${filedrag_SRC}
  ${kernel_SRC}
  ${util_SRC}
  ${private_SRC}
)
if(NOT DTK_DISABLE_LIBXDG)
  target_link_libraries(
    ${LIB_NAME} PRIVATE 
    Qt5::Gui 
    Qt5::DBus 
    Qt5::Network
    Qt5XdgIconLoader
    ${librsvg_LIBRARIES}
    ${DtkCore_LIBRARIES}
  )
  
  target_include_directories(${LIB_NAME} PUBLIC
    ${CMAKE_CURRENT_LIST_DIR}/../include/util/ 
    ${CMAKE_CURRENT_LIST_DIR}/../include/DtkGui/ 
    ${CMAKE_CURRENT_LIST_DIR}/../include/global/ 
    ${CMAKE_CURRENT_LIST_DIR}/../include/kernel/ 
    ${CMAKE_CURRENT_LIST_DIR}/../include/filedrag/ 
    ${CMAKE_CURRENT_LIST_DIR}/../include/
    ${CMAKE_CURRENT_LIST_DIR}/private/
    ${librsvg_INCLUDE_DIRS}
    ${Qt5Core_PRIVATE_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${DtkCore_INCLUDE_DIRS}
  )
else()
  target_link_libraries(
    ${LIB_NAME} PRIVATE 
    Qt5::Gui 
    Qt5::DBus 
    Qt5::Network
    ${librsvg_LIBRARIES}
    ${DtkCore_LIBRARIES}
  )
  
  target_include_directories(${LIB_NAME} PUBLIC
    ${CMAKE_CURRENT_LIST_DIR}/../include/util/ 
    ${CMAKE_CURRENT_LIST_DIR}/../include/DtkGui/ 
    ${CMAKE_CURRENT_LIST_DIR}/../include/global/ 
    ${CMAKE_CURRENT_LIST_DIR}/../include/kernel/ 
    ${CMAKE_CURRENT_LIST_DIR}/../include/filedrag/ 
    ${CMAKE_CURRENT_LIST_DIR}/../include/
    ${CMAKE_CURRENT_LIST_DIR}/private/
    ${librsvg_INCLUDE_DIRS}
    ${Qt5Core_PRIVATE_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${DtkCore_INCLUDE_DIRS}
  )
endif()
set_target_properties(${LIB_NAME} PROPERTIES
  VERSION ${CMAKE_PROJECT_VERSION}
  SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR}
)
install(TARGETS ${LIB_NAME} DESTINATION "${LIBRARY_INSTALL_DIR}")
install(DIRECTORY ../include/util/ DESTINATION "${INCLUDE_INSTALL_DIR}" FILES_MATCHING PATTERN "*")
install(DIRECTORY ../include/DtkGui/ DESTINATION "${INCLUDE_INSTALL_DIR}" FILES_MATCHING PATTERN "*")
install(DIRECTORY ../include/global/ DESTINATION "${INCLUDE_INSTALL_DIR}" FILES_MATCHING PATTERN "*")
install(DIRECTORY ../include/kernel/ DESTINATION "${INCLUDE_INSTALL_DIR}" FILES_MATCHING PATTERN "*")
install(DIRECTORY ../include/filedrag/ DESTINATION "${INCLUDE_INSTALL_DIR}" FILES_MATCHING PATTERN "*")

=== tests/CMakeLists.txt ===
set(BIN_NAME "ut-${PROJECT_NAME}")
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

find_package(DtkCore REQUIRED)
find_package(Qt5 REQUIRED COMPONENTS Gui)
find_package(Qt5 REQUIRED COMPONENTS Widgets)
find_package(Qt5 REQUIRED COMPONENTS DBus)
find_package(Qt5 REQUIRED COMPONENTS Network)
find_package(Qt5 REQUIRED COMPONENTS Test)
find_package(GTest REQUIRED)
find_package(PkgConfig REQUIRED)
#pkg_check_modules(GMOCK REQUIRED gmock)
add_definitions(-DTEST)

set(CMAKE_CXX_FLAGS "-fno-access-control")
add_compile_options(-fsanitize=address)
add_link_options(-fsanitize=address)

include(../src/dbus/dbus.cmake)
include(../src/kernel/kernel.cmake)
include(../src/util/util.cmake)
include(../src/private/private.cmake)

file(GLOB test_SRC 
  res.qrc
  test.h
  main.cpp 
  src/*.cpp
)
add_executable(${BIN_NAME}
  ${dbus_SRC}
  ${kernel_SRC}
  ${util_SRC}
  ${private_SRC}
  ${test_SRC}
)
set(LIBRARIES 
    ${DtkCore_LIBRARIES}
    Qt5::Gui 
    Qt5::Widgets
    Qt5::DBus 
    Qt5::Network 
    Qt5::Test 
    ${librsvg_LIBRARIES}
    ${GTEST_LIBRARIES}
    ${GMOCK_LIBRARIES}
    -lpthread
    -lgmock
    -lm 
    -lgcov
)

if(NOT DTK_DISABLE_LIBXDG)
  list(APPEND LIBRARIES Qt5XdgIconLoader)
endif()

target_link_libraries(${BIN_NAME} PRIVATE 
  ${LIBRARIES}
)

if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  target_compile_options(${BIN_NAME} PRIVATE -fprofile-instr-generate -ftest-coverage)
endif()
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  target_compile_options(${BIN_NAME} PRIVATE -fprofile-arcs -ftest-coverage)
endif()
target_include_directories(${BIN_NAME} PUBLIC
  ../include/util/
  ../include/DtkGui/
  ../include/global/
  ../include/kernel/
  ../include/filedrag/
  ../src/private/
  ../src/
  ${librsvg_INCLUDE_DIRS}
  ${GMOCK_INCLUDE_DIRS}
  ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
)
add_test(NAME ${BIN_NAME} COMMAND ${BIN_NAME})

=== examples/dnd-example/CMakeLists.txt ===
set(CMAKE_AUTOMOC ON)
find_package(DtkCore REQUIRED)
find_package(Qt5 REQUIRED COMPONENTS Widgets)
find_package(Qt5 REQUIRED COMPONENTS DBus)

set(BIN1 dnd-test-client)

add_executable(${BIN1}
  dnd-test-client.cpp
)

target_link_libraries(
  ${BIN1} PRIVATE
  Qt5::Widgets 
  Qt5::DBus 
  dtkgui
  ${DtkCore_LIBRARIES}
)

install(TARGETS ${BIN1} DESTINATION "${TOOL_INSTALL_DIR}")
set(BIN2 dnd-test-server)

add_executable(${BIN2}
  dnd-test-server.cpp
)

target_link_libraries(
  ${BIN2} PRIVATE
  Qt5::Widgets 
  Qt5::DBus 
  dtkgui
  ${DtkCore_LIBRARIES}
)


install(TARGETS ${BIN2} DESTINATION "${TOOL_INSTALL_DIR}")

=== examples/test-taskbar/CMakeLists.txt ===
set(CMAKE_AUTOMOC ON)
find_package(DtkCore REQUIRED)
find_package(Qt5 REQUIRED COMPONENTS Widgets)
find_package(Qt5 REQUIRED COMPONENTS Gui)

set(BIN taskbar)

add_executable(${BIN}
  testtaskbarwindow.h 
  testtaskbarwindow.cpp
  main.cpp
)

target_link_libraries(
  ${BIN} PRIVATE
  Qt5::Widgets 
  Qt5::Gui 
  dtkgui
  ${DtkCore_LIBRARIES}
)

=== tools/dci-image-converter/CMakeLists.txt ===
set(BIN_NAME dci-image-converter)
find_package(Qt5 REQUIRED COMPONENTS Core)
find_package(Qt5 REQUIRED COMPONENTS Gui)

add_executable(${BIN_NAME}
  main.cpp
)
target_link_libraries(${BIN_NAME} PRIVATE
  Qt5::Core
  Qt5::Gui
)

=== tools/dde-kwin-debug/CMakeLists.txt ===
set(BIN dde-kwin-bug)
find_package(PkgConfig REQUIRED)
pkg_check_modules(x11 REQUIRED x11)

add_executable(${BIN}
  main.cpp 
)
target_link_libraries(${BIN} PRIVATE 
  ${x11_LIBRARIES}
  -lpthread
)
target_include_directories(${BIN} PUBLIC
  ${x11_INCLUDE_DIRS}
)
install(TARGETS ${BIN} DESTINATION "${TOOL_INSTALL_DIR}")

=== debian/changelog ===
dtkgui (5.6.2.2+2-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Wed, 07 Dec 2022 16:46:48 +0800

=== debian/control ===
Source: dtkgui
Section: libdevel
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends: debhelper (>= 9), pkg-config, 
 qtbase5-private-dev, qtbase5-dev-tools, doxygen, qttools5-dev-tools,
 libdtkcore-dev, librsvg2-dev, libgtest-dev, libgmock-dev,
 libqt5xdg-dev, libqt5xdgiconloader-dev, cmake
Standards-Version: 3.9.8

Package: libdtkgui5
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libdtkcommon,
 qt5-image-formats-plugins
Multi-Arch: same
Description: Deepin Tool Kit Gui library
 DtkGui is base library of Deepin Qt/C++ applications.
 .
 This package contains the shared libraries.

Package: libdtkgui5-bin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libdtkgui5( =${binary:Version})
Description: Deepin Tool Kit Gui Utilities
 DtkGui is base devel library of Deepin Qt/C++ applications.
 .
 This package contains the utilities of DtkGui

Package: libdtkgui-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libdtkgui5( =${binary:Version})
Description: Deepin Tool Kit Gui Devel library
 DtkGui is base devel library of Deepin Qt/C++ applications.
 .
 This package contains the header files and static libraries of DtkGui

Package: libdtkgui-doc
Architecture: any
Description: Deepin Tool Kit Gui (Document)
 DtkGui is base devel library of Deepin Qt/C++ applications.
 .
 This package contains the qt Document of DtkGui

=== debian/rules ===
#!/usr/bin/make -f
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
export QT_SELECT = qt5

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

VERSION = $(DEB_VERSION_UPSTREAM)
_PACK_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$1}')
_BUILD_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$2}' | sed 's/[^0-9]//g' | awk '{print int($$1)}')
ifeq ($(_BUILD_VER),)
	CONFIG_VERSION = $(_PACK_VER)
else
	CONFIG_VERSION = $(_PACK_VER).$(_BUILD_VER)
endif

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_TESTING=OFF -DBUILD_DOCS=ON -DDVERSION=$(_PACK_VER)
#override_dh_auto_test:
#	echo "skip auto test"

override_dh_makeshlibs:
	dh_makeshlibs  -V "libdtkgui5 (>= $(shell echo $(VERSION) | cut -d '.' -f 1,2))"

## dtkgui 5.6.4

=== docs/CMakeLists.txt ===
--- 
+++ 
@@ -21,15 +21,21 @@
 
 set (DOXYGEN_PREDEFINED
     "D_DECL_DEPRECATED_X(x)="
-    "\"DCORE_BEGIN_NAMESPACE=namespace Dtk { namespace Core {\""
-    "\"DCORE_END_NAMESPACE=}}\""
-    "\"DCORE_USE_NAMESPACE=using namespace Dtk::Core\;\""
-    "\"DGUI_BEGIN_NAMESPACE=namespace Dtk { namespace Gui {\""
-    "\"DGUI_END_NAMESPACE=}}\""
-    "\"DGUI_USE_NAMESPACE=using namespace Dtk::Gui\;\""
+    "DCORE_BEGIN_NAMESPACE=namespace Dtk { namespace Core {"
+    "DCORE_END_NAMESPACE=}}"
+    "DCORE_USE_NAMESPACE=using namespace Dtk::Core\;"
+    "DGUI_BEGIN_NAMESPACE=namespace Dtk { namespace Gui {"
+    "DGUI_END_NAMESPACE=}}"
+    "DGUI_USE_NAMESPACE=using namespace Dtk::Gui\;"
 )
 set (DOXYGEN_MACRO_EXPANSION "YES")
 set (DOXYGEN_EXPAND_ONLY_PREDEF "YES")
+
+# Exclude private classes.
+set (DOXYGEN_EXCLUDE_PATTERNS 
+    ${PROJECT_SOURCE_DIR}/src/util/private/dimagehandlerlibs_p.h
+    ${PROJECT_SOURCE_DIR}/src/util/dimagehandlerlibs.cpp
+    )
 
 doxygen_add_docs (doxygen
     ${PROJECT_SOURCE_DIR}/src

=== examples/CMakeLists.txt ===
add_subdirectory(dnd-example)
add_subdirectory(test-taskbar)
add_subdirectory(imagehandler-example)
#add_subdirectory(frameless-window) # Don't build

=== src/CMakeLists.txt ===
add_library(${LIB_NAME} SHARED)

include(dbus/dbus.cmake)
include(filedrag/dfiledrag.cmake)
include(kernel/kernel.cmake)
include(private/private.cmake)
include(util/util.cmake)

target_sources(${LIB_NAME} PRIVATE
	${dbus_SRC}
	${filedrag_SRC}
	${kernel_SRC}
	${util_SRC}
	${private_SRC}
)

target_include_directories(${LIB_NAME} PUBLIC
	$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/util>
	$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/global>
	$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/kernel>
	$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/filedrag>
	$<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/dbus>
	$<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/private>
	$<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/util/private>
	$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/DtkGui>
)

target_link_libraries(${LIB_NAME} PRIVATE
	Qt5::GuiPrivate
	Qt5::CorePrivate
	PkgConfig::librsvg
	FreeImage::FreeImage
)

target_link_libraries(${LIB_NAME} PUBLIC
	Qt5::Gui
	Qt5::DBus
	Qt5::Network
	Dtk::Core
)

if(NOT DTK_DISABLE_LIBXDG)
	target_link_libraries(${LIB_NAME} PRIVATE
		Qt5XdgIconLoader
	)
endif()

set_target_properties(${LIB_NAME} PROPERTIES
	VERSION ${CMAKE_PROJECT_VERSION}
	SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR}
	EXPORT_NAME Gui
)

target_include_directories(${LIB_NAME} INTERFACE
	$<INSTALL_INTERFACE:${INCLUDE_INSTALL_DIR}>
)

target_link_directories(${LIB_NAME} INTERFACE
	$<INSTALL_INTERFACE:${LIBRARY_INSTALL_DIR}>
)

install(TARGETS ${LIB_NAME} EXPORT DtkGuiTargets DESTINATION "${LIBRARY_INSTALL_DIR}")
install(EXPORT DtkGuiTargets NAMESPACE Dtk:: FILE DtkGuiTargets.cmake DESTINATION "${CONFIG_INSTALL_DIR}")
install(DIRECTORY ../include/util/ DESTINATION "${INCLUDE_INSTALL_DIR}" FILES_MATCHING PATTERN "*")
install(DIRECTORY ../include/DtkGui/ DESTINATION "${INCLUDE_INSTALL_DIR}" FILES_MATCHING PATTERN "*")
install(DIRECTORY ../include/global/ DESTINATION "${INCLUDE_INSTALL_DIR}" FILES_MATCHING PATTERN "*")
install(DIRECTORY ../include/kernel/ DESTINATION "${INCLUDE_INSTALL_DIR}" FILES_MATCHING PATTERN "*")
install(DIRECTORY ../include/filedrag/ DESTINATION "${INCLUDE_INSTALL_DIR}" FILES_MATCHING PATTERN "*")

=== tests/CMakeLists.txt ===
set(BIN_NAME ut-dtkgui)

find_package(Qt5 REQUIRED COMPONENTS Widgets Test)
find_package(GTest REQUIRED)

include(../src/dbus/dbus.cmake)
include(../src/kernel/kernel.cmake)
include(../src/util/util.cmake)
include(../src/private/private.cmake)

file(GLOB test_SRC
    res.qrc
    test.h
    main.cpp
    src/*.cpp
)

add_executable(${BIN_NAME}
    ${dbus_SRC}
    ${kernel_SRC}
    ${util_SRC}
    ${private_SRC}
    ${test_SRC}
)

target_compile_options(${BIN_NAME} PRIVATE -fno-access-control -fsanitize=address)
target_link_options(${BIN_NAME} PRIVATE -fsanitize=address)

target_link_libraries(${BIN_NAME} PRIVATE
    Qt5::Gui
    Qt5::GuiPrivate
    Qt5::Widgets
    Qt5::DBus
    Qt5::Network
    Qt5::Test
    Dtk::Core
    PkgConfig::librsvg
    GTest::gtest
    gmock
    pthread
    m
    gcov
)

if(NOT DTK_DISABLE_LIBXDG)
    target_link_libraries(${BIN_NAME} PRIVATE 
        Qt5XdgIconLoader
    )
endif()

target_include_directories(${BIN_NAME} PRIVATE
    ${PROJECT_SOURCE_DIR}/include/util
    ${PROJECT_SOURCE_DIR}/include/DtkGui
    ${PROJECT_SOURCE_DIR}/include/global
    ${PROJECT_SOURCE_DIR}/include/kernel
    ${PROJECT_SOURCE_DIR}/include/filedrag
    ${PROJECT_SOURCE_DIR}/src/private
    ${PROJECT_SOURCE_DIR}/src
    ${PROJECT_SOURCE_DIR}/src/dbus
    ${PROJECT_SOURCE_DIR}/src/util/private
)

if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  target_compile_options(${BIN_NAME} PRIVATE -fprofile-instr-generate -ftest-coverage)
endif()
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  target_compile_options(${BIN_NAME} PRIVATE -fprofile-arcs -ftest-coverage)
endif()

add_test(NAME ${BIN_NAME} COMMAND ${BIN_NAME})

=== tools/CMakeLists.txt ===
add_subdirectory(deepin-gui-settings)
add_subdirectory(dci-image-converter)
add_subdirectory(dci-icon-theme)
add_subdirectory(dde-kwin-debug)

=== examples/dnd-example/CMakeLists.txt ===
find_package(Qt5 REQUIRED COMPONENTS Widgets)

set(BIN1 dnd-test-client)

add_executable(${BIN1}
    dnd-test-client.cpp
)

target_link_libraries(${BIN1} PRIVATE
    Qt5::Widgets
    Qt5::DBus
    ${LIB_NAME}
    Dtk::Core
)

install(TARGETS ${BIN1} DESTINATION "${TOOL_INSTALL_DIR}")

set(BIN2 dnd-test-server)

add_executable(${BIN2}
    dnd-test-server.cpp
)

target_link_libraries(${BIN2} PRIVATE
    Qt5::Widgets
    Qt5::DBus
    ${LIB_NAME}
    Dtk::Core
)

install(TARGETS ${BIN2} DESTINATION "${TOOL_INSTALL_DIR}")

=== examples/frameless-window/CMakeLists.txt ===
find_package(Qt5 REQUIRED COMPONENTS X11Extras)
pkg_check_modules(XCB IMPORTED_TARGET xcb)

set(BIN_NAME frameless-window)

add_executable(${BIN_NAME}
    main.cpp
)

target_link_libraries(${BIN_NAME} PRIVATE
    Qt5::Gui
    Qt5::GuiPrivate
    Qt5::X11Extras
    PkgConfig::XCB
)

=== examples/imagehandler-example/CMakeLists.txt ===
set(BIN imagehandler)

add_executable(${BIN}
    main.cpp
)

target_link_libraries(${BIN} PRIVATE
    Qt5::Gui
    ${LIB_NAME}
    Dtk::Core
)

=== tools/dci-icon-theme/CMakeLists.txt ===
set(BIN_NAME dci-icon-theme)

add_executable(${BIN_NAME}
    main.cpp
)
target_link_libraries(${BIN_NAME} PRIVATE
    Qt5::Gui
    Dtk::Core
)

install(TARGETS ${BIN_NAME} DESTINATION "${TOOL_INSTALL_DIR}")

=== tools/dci-image-converter/CMakeLists.txt ===
set(BIN_NAME dci-image-converter)

add_executable(${BIN_NAME}
    main.cpp
)

target_link_libraries(${BIN_NAME} PRIVATE
    Qt5::Core
    Qt5::Gui
)

=== tools/deepin-gui-settings/CMakeLists.txt ===
set(BIN_NAME deepin-gui-settings)

find_package(Qt5 REQUIRED COMPONENTS Widgets)

add_executable(${BIN_NAME} 
  	main.cpp
)

target_link_libraries(${BIN_NAME}
	Qt5::Widgets
	Dtk::Core
	${LIB_NAME}
)

install(TARGETS ${BIN_NAME} DESTINATION "${TOOL_INSTALL_DIR}")

=== debian/changelog ===
dtkgui (5.6.4-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Tue, 17 Jan 2023 13:17:35 +0800

dtkgui (5.6.4) unstable; urgency=medium

  * Release 5.6.4

 -- Deepin Packages Builder <packages@deepin.com>  Mon, 09 Jan 2023 13:28:09 +0800

dtkgui (5.6.3) unstable; urgency=medium

  * Release 5.6.3

 -- Deepin Packages Builder <packages@deepin.com>  Mon, 12 Dec 2022 14:44:49 +0800

## dtkgui 5.6.4.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

set(DVERSION "5.6.2" CACHE STRING "define project version")
project(DtkGui
  VERSION ${DVERSION}
  DESCRIPTION "DTK Gui module"
  HOMEPAGE_URL "https://github.com/linuxdeepin/dtkgui"
  LANGUAGES CXX C
)
set(LIB_NAME dtkgui)

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)
list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Set build option
option(DTK_DISABLE_LIBXDG "Disable libxdg" OFF)
set(BUILD_DOCS ON CACHE BOOL "Generate doxygen-based documentation")

# Set install path
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

set(INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_INCLUDEDIR}/dtk${PROJECT_VERSION_MAJOR}/DGui")
set(TOOL_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/dtk${PROJECT_VERSION_MAJOR}/DGui/bin")
set(LIBRARY_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}")
set(MKSPECS_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/qt5/mkspecs/modules" CACHE STRING "Install dir for qt pri module files")
set(CONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/DtkGui")
set(PKGCONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -Wall -Wextra")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--as-needed")
set(CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS} -pie")
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(BUILD_TESTING ON)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O0 -g -fno-omit-frame-pointer")
else ()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Ofast")
endif ()

set(CONFIGNAME include/global/dtkgui_config.h)
file(WRITE ${CONFIGNAME} 
  "// This is an auto-generated header, please don't modify it.\n"
)
file(GLOB CONFIGSOURCE include/DtkGui/*)

foreach(FILENAME ${CONFIGSOURCE})
  get_filename_component(thefile ${FILENAME} NAME)
  file(APPEND ${CONFIGNAME} "#define DTKGUI_CLASS_${thefile}\n")
endforeach()

# Generate cmake config file
configure_package_config_file(misc/DtkGuiConfig.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/DtkGuiConfig.cmake
    INSTALL_DESTINATION "${CONFIG_INSTALL_DIR}"
    PATH_VARS TOOL_INSTALL_DIR
)
# Generate cmake version file
write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/DtkGuiConfigVersion.cmake"
    VERSION ${DVERSION}
    COMPATIBILITY SameMajorVersion
)
# Install cmake config file and version file to CONFIG_INSTALL_DIR
install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/DtkGuiConfig.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/DtkGuiConfigVersion.cmake
    DESTINATION "${CONFIG_INSTALL_DIR}"
)
# Install pkgconfig file
configure_file(misc/dtkgui.pc.in dtkgui.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/dtkgui.pc DESTINATION "${PKGCONFIG_INSTALL_DIR}")
# Install pri module
configure_file(misc/qt_lib_dtkgui.pri.in qt_lib_dtkgui.pri @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qt_lib_dtkgui.pri DESTINATION "${MKSPECS_INSTALL_DIR}")

set(GUISGNAME DtkGuis)

file(WRITE ${GUISGNAME} 
  "// This is an auto-generated header, please don't modify it.\n"
  "#ifndef DTK_GUI_MODULE_H\n"
  "#define DTK_GUI_MODULE_H\n"
)
file(GLOB FILEGRAGTOWRITSOURCE include/filedrag/*)

foreach(FILENAME ${FILEGRAGTOWRITSOURCE})
  get_filename_component(thefile ${FILENAME} NAME)
  file(APPEND ${GUISGNAME} "#include \"${thefile}\"\n")
endforeach()
file(GLOB KERNELTOWRITESOURCE include/kernel/*)
foreach(FILENAME ${KERNELTOWRITESOURCE})
  get_filename_component(thefile ${FILENAME} NAME)
  file(APPEND ${GUISGNAME} "#include \"${thefile}\"\n")
endforeach()
file(GLOB UTILTOWRITESOURCE include/util/*)
foreach(FILENAME ${UTILTOWRITESOURCE})
  get_filename_component(thefile ${FILENAME} NAME)
  file(APPEND ${GUISGNAME} "#include \"${thefile}\"\n")
endforeach()
file(APPEND ${GUISGNAME} "#endif")
install(FILES DtkGuis DESTINATION "${INCLUDE_INSTALL_DIR}")

# Find common dependencies
find_package(Qt5 REQUIRED COMPONENTS Gui DBus Network)
find_package(PkgConfig REQUIRED)
find_package(FreeImage REQUIRED)
find_package(DtkCore 5.6 REQUIRED)
pkg_check_modules(librsvg REQUIRED IMPORTED_TARGET librsvg-2.0)

add_subdirectory(src)
if(BUILD_TESTING)
    enable_testing()
    add_subdirectory(tests)
endif()
add_subdirectory(tools)
add_subdirectory(examples)

if (BUILD_DOCS)
  add_subdirectory(docs)
endif ()

=== examples/test-taskbar/CMakeLists.txt ===
find_package(Qt5 REQUIRED COMPONENTS Widgets)

set(BIN taskbar)

add_executable(${BIN}
    testtaskbarwindow.h 
    testtaskbarwindow.cpp
    main.cpp
)

target_link_libraries(${BIN} PRIVATE
    Qt5::Widgets
    Qt5::Gui
    ${LIB_NAME}
    Dtk::Core
)

=== tools/dde-kwin-debug/CMakeLists.txt ===
set(BIN_NAME dde-kwin-bug)
pkg_check_modules(X11 IMPORTED_TARGET REQUIRED x11)

add_executable(${BIN_NAME}
    main.cpp
)
target_link_libraries(${BIN_NAME} PRIVATE 
    PkgConfig::X11
    pthread
)

install(TARGETS ${BIN_NAME} DESTINATION "${TOOL_INSTALL_DIR}")

=== debian/changelog ===
dtkgui (5.6.4.1-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Thu, 21 Sep 2023 08:57:27 +0800

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,9 @@
 Section: libdevel
 Priority: optional
 Maintainer: Deepin Packages Builder <packages@deepin.com>
-Build-Depends: debhelper (>= 9), pkg-config, 
- qtbase5-private-dev, qtbase5-dev-tools, doxygen, qttools5-dev-tools,
- libdtkcore-dev, librsvg2-dev, libgtest-dev, libgmock-dev,
+Build-Depends: debhelper-compat (= 12), pkg-config, 
+ qtbase5-private-dev, qtbase5-dev-tools, doxygen, graphviz, qttools5-dev-tools,
+ libdtkcore-dev, librsvg2-dev, libfreeimage-dev, libgtest-dev, libgmock-dev,
  libqt5xdg-dev, libqt5xdgiconloader-dev, cmake
 Standards-Version: 3.9.8
 
@@ -37,6 +37,7 @@
 
 Package: libdtkgui-doc
 Architecture: any
+Depends: ${misc:Depends}
 Description: Deepin Tool Kit Gui (Document)
  DtkGui is base devel library of Deepin Qt/C++ applications.
  .

=== debian/rules ===
--- 
+++ 
@@ -15,7 +15,7 @@
 endif
 
 %:
-	dh $@ --parallel
+	dh $@
 
 override_dh_auto_configure:
 	dh_auto_configure -- -DBUILD_TESTING=OFF -DBUILD_DOCS=ON -DDVERSION=$(_PACK_VER)
